open Cfg

exception Anomaly of string

(* Représente une variable / registre *)
type position = Loc of location | Reg of register

(* Formate une position *)
let pp_position p =
  let open Format in
  function
  | Loc l -> fprintf p "%a" PrettyPrinter.pp_location l
  | Reg r -> fprintf p "Register %a" PrettyPrinter.pp_register r

module LocMap = Map.Make (struct
  type t = position

  let compare = compare
end)

